<?php
/**
 *	Copyright © 2006-2008 CraKteR, crakter [at] gmail [dot] com
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *	@version $Id: bdaymailer.php 24 2008-08-14 18:38:04Z CraKteR $
 *	@copyright $LastChangedDate: 2008-08-14 20:38:04 +0200 (to, 14 aug 2008) $
 *	@author CraKteR <crakter@gmail.com>
 */
 
/** 
* Polish Language File developed by mybboard.pl for Birthday Mailer 2.0
* Tłumaczenie: szulcu
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1.0 **/ 

if(!defined("IN_MYBB"))
{
    die("This file cannot be accessed directly.");
}

$plugins->add_hook("global_end", "bdaymailer_run");

function bdaymailer_info()
{
    return array(
        "name"				=> "Birthday Mailer",
        "description"		=> "Pozwala wysyłać życzenia urodzinowe do użytkowników w dniu rocznicy ich urodzin.",
        "website"			=> "",
        "author"			=> "CraKteR",
        "authorsite"		=> "mailto:crakter@gmail.com",
        "version"			=> "2.0",
		"guid" 				=> "",
		"compatibility" 	=> "14*"
    );
}

function bdaymailer_activate()
{
	global $db;

	$query = $db->query("SELECT gid FROM ".TABLE_PREFIX."settinggroups ORDER BY `gid` DESC LIMIT 0,1");
	$disporder = $db->fetch_field($query, 'gid')+1;

	$setting_group = array(
		"name" =>			"bdm",
		"title" =>			"Birthday Mailer",
		"description" =>	"",
		"disporder" =>		intval($disporder),
		"isdefault" =>		"no"
	);
	$db->insert_query("settinggroups", $setting_group);
	$gid = $db->insert_id();

	$s_4 = array(
		"name"			=> "subjectbdaym",
		"title"			=> "Temat wiadomości",
		"description"	=> "{username} zamieni się w nazwę użytkownika, {uid} w identyfikator użytkownika, {age} w wiek użytkownika, {date} w bieżącą datę. Nie można używać tutaj BBCode.",
		"optionscode"	=> "text",
		"value"			=> "Wszystkiego najlepszego, {username}!",
		"disporder"		=> 1,
		"gid"			=> intval($gid)
	);
	$db->insert_query("settings", $s_4);

	$s_1 = array(
		"name"			=> "htmlbdaym",
		"title"			=> "Treść wiadomości w HTML",
		"description"	=> "Podaj treść wiadomości w formacie HTML. {username} zamieni się w nazwę użytkownika, {uid} w identyfikator użytkownika, {age} w wiek użytkownika, {date} w bieżącą datę. Nie można używać tutaj BBCode.",
		"optionscode"	=> "textarea",
		"value"			=> "Wszystkiego najlepszego z okazji urodzin, [b]{username}[/b]!",
		"disporder"		=> 2,
		"gid"			=> intval($gid)
	);
	$db->insert_query("settings", $s_1);

	$s_2 = array(
		"name"			=> "plainbdaym",
		"title"			=> "Treść wiadomości w formacie zwykły tekst",
		"description"	=> "Podaj treść wiadomości w formacie zwykły tekst {username} zamieni się w nazwę użytkownika, {uid} w identyfikator użytkownika, {age} w wiek użytkownika, {date} w bieżącą datę. Nie można używać tutaj BBCode.",
		"optionscode"	=> "textarea",
		"value"			=> "Wszystkiego najlepszego z okazji urodzin, {username}!",
		"disporder"		=> 3,
		"gid"			=> intval($gid)
	);
	$db->insert_query("settings", $s_2);

	$s_3 = array(
		"name"			=> "switchbdaym",
		"title"			=> "Wysyłaj wiadomości w formacie",
		"description"	=> "Wpisz wartość \"plain\" (bez cudzysłowów) aby wiadomość zostałą wysłana w formacie zwykłego tekstu lub \"html\" (również bez cudzysłowów), aby wiadomość została wysłana w formacie HTML. Wysłanie wiadomości w formacie zwykły tekst trwa krócej niż tej samej wiadomości w formacie HTML.",
		"optionscode"	=> "text",
		"value"			=> "plain",
		"disporder"		=> 4,
		"gid"			=> intval($gid)
	);
	$db->insert_query("settings", $s_3);

	$s_5 = array(
		"name"			=> "dontsendto",
		"title"			=> "Zablokowane grupy",
		"description"	=> "Grupy do których wiadomość nie zostanie wysłana. Rozdzielaj znakami \',\'.",
		"optionscode"	=> "text",
		"value"			=> "",
		"disporder"		=> 5,
		"gid"			=> intval($gid)
	);
	$db->insert_query("settings", $s_5);

	$s_6 = array(
		"name"			=> "bdaym",
		"title"			=> "",
		"description"	=> "",
		"optionscode"	=> "hidden",
		"value"			=> "",
		"disporder"		=> 6,
		"gid"			=> intval($gid)
	);
	$db->insert_query("settings", $s_6);

	rebuild_settings();
}

function bdaymailer_deactivate()
{
	global $db;
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='bdm'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('subjectbdaym', 'htmlbdaym', 'plainbdaym', 'switchbdaym', 'bdaym')");
	rebuild_settings();
}

function bdaymailer_run()
{
	global $db, $mybb;

	$bdaydate = date("j-n");
	$year = date("Y");

	$query = $db->simple_select('users', 'uid, username, birthday, email, usergroup', "birthday LIKE '{$bdaydate}-%' AND email != ''");
	$comma = '';
	$query2 = $db->simple_select('settings', 'value', "name='bdaym'");
	$string = $db->fetch_field($query2, 'value');
	$usersdone = array();

	if($string != '')
	{
		$string = my_substr($string, 0, my_strlen($string)-1);
		$array = explode(',', $string);
		$string .= ",";
		foreach($array as $array2)
		{
			$user = explode('|', $array2);
			if($user[0] != $bdaydate)
			{
				$string = str_replace($array2.',', '', $string);
			}
			else
			{
				$usersdone[] = $user[1];
			}
		}
	}

	$users = array();
	$dontsend = explode(',', $mybb->settings['dontsendto']);

	while($user = $db->fetch_array($query))
	{
		if(in_array($user['uid'], $usersdone) || in_array($user['usergroup'], $dontsend))
		{
			continue;
		}

		$bday = explode("-", $user['birthday']);
		$switch = stripslashes(strtolower($mybb->settings['switchbdaym']));
		$age = ($year > $bday[2] && $bday[2] != '') ? " (".($year - $bday[2]).")" : "";

		if($switch != 'plain')
		{
			$content = stripslashes($mybb->settings['htmlbdaym']);
		}
		else
		{
			$content = stripslashes($mybb->settings['plainbdaym']);
		}

		$title = stripslashes($mybb->settings['subjectbdaym']);

		if($switch != "plain")
		{
			require_once MYBB_ROOT."inc/class_parser.php";
			$parser = new postParser;
			$parser_options = array(
				"allow_html" => true,
				"allow_mycode" => true,
				"allow_smilies" => true,
				"allow_imgcode" => true,
				"nl2br"			=> true
			);
			$content = $parser->parse_message($content, $parser_options);
		}

		$search = array(
			'{username}',
			'{uid}',
			'{age}',
			'{date}'
		);

		$replace = array(
			htmlspecialchars_uni($user['username']),
			htmlspecialchars_uni($user['uid']),
			htmlspecialchars_uni($age),
			$bdaydate."-".$year
		);

		$content = str_replace($search, $replace, $content);

		$title = str_replace($search, $replace, $title);

		my_mail($user['email'], $title, $content);

		$users[] = $user['uid'];
	}

	foreach($users as $uid)
	{
		$string .= $bdaydate."|".$uid.",";
	}

	$db->query("UPDATE ".TABLE_PREFIX."settings SET value='{$string}' WHERE name='bdaym'");
}
?>